'use strict';
var express = require('express'),
	router = express.Router(),
	returnCode = require('../../utils/returnCode'),
	_ = require('lodash');
var mongoose = require('mongoose');
var ForumRole = mongoose.model('ForumRole');
module.exports = function(app) {
	app.use('/admin/forum', router);
};

//新增论坛角色
router.post('/role/create', function(req, res, next) {
	var rs = {};
	req.body.ent_code=req.session.user.ent_code;
	var forum = new ForumRole(req.body);
	forum.save(function(err, forum) {
		if (err) {
			console.error(err);
			res.json(returnCode.BUSY);
		} else {
			rs.data = forum;
			res.json(_.assign(rs, returnCode.SUCCESS));
		}
	});
});

//删除论坛角色
router.post('/role/:rid/delete', function(req, res, next) {
	var rid=req.params.rid;

	ForumRole.remove({ _id: rid},function(err,result){
		if (err) {
			console.error(err);
			res.json(returnCode.BUSY);
		} else {
			res.json(returnCode.SUCCESS);
		}
	});
});

//更新论坛角色
router.post('/role/:rid/update', function(req, res, next) {
	var rid=req.params.rid;

	ForumRole.update({ _id: rid}, req.body,null,function(err,result){
		if (err) {
			console.error(err);
			res.json(returnCode.BUSY);
		} else {
			res.json(returnCode.SUCCESS);
		}
	});
});

//获取角色列表
router.get('/role/list', function(req, res, next) {
	var pageNo = req.query.pageNo || 1;
    var pageSize = req.query.pageSize || 10;

	var rs = {};
	ForumRole.count({ent_code:req.session.user.ent_code,status:1}, function (err, count) {
	   if(err){
	   		console.error(err);
			res.json(returnCode.BUSY);
	   }else{
	   		var skip = (pageNo - 1) * pageSize;
            var limit = count - skip > pageSize ? pageSize : (count - skip);
            ForumRole.find({ent_code:req.session.user.ent_code,status:1}, null, {skip: skip,limit:limit},function(err,docs){
				if (err) {
					console.error(err);
					res.json(returnCode.BUSY);
				} else {
					rs.total=count;
					rs.pageNo=pageNo;
					rs.pageSize=pageSize;
					rs.items=docs;
					res.json(_.assign(rs, returnCode.SUCCESS));
				}
			});
	   }
	});
});
