'use strict';
var express = require('express'),
	router = express.Router(),
	returnCode = require('../../utils/returnCode'),
	_ = require('lodash');
var mongoose = require('mongoose');
var ForumTag = mongoose.model('ForumTag');
var ForumThread = mongoose.model('ForumThread');
module.exports = function(app) {
	app.use('/admin/forum', router);
};

//新增论坛标签
router.post('/tag/create', function(req, res, next) {
	var rs = {};
	req.body.ent_code=req.session.user.ent_code;
	var forum = new ForumTag(req.body);
	forum.save(function(err, forum) {
		if (err) {
			console.error(err);
			res.json(returnCode.BUSY);
		} else {
			rs.data = {'id':forum._id};
			res.json(_.assign(rs, returnCode.SUCCESS));
		}
	});
});

//删除论坛标签
router.post('/tag/:tid/delete', function(req, res, next) {
	var tid=req.params.tid;

	ForumTag.remove({ _id: tid},function(err,result){
		if (err) {
			console.error(err);
			res.json(returnCode.BUSY);
		} else {
			res.json(returnCode.SUCCESS);
		}
	});
});

//更新论坛标签
router.post('/tag/:tid/update', function(req, res, next) {
	var tid=req.params.tid;

	ForumTag.update({ _id: tid}, req.body,null,function(err,result){
		if (err) {
			console.error(err);
			res.json(returnCode.BUSY);
		} else {
			res.json(returnCode.SUCCESS);
		}
	});
});

//获取论坛标签
router.get('/tag/:tid/get', function(req, res, next) {
	var tid = req.params.tid || null;
	var rs = {};
	if (fid) {
		ForumTag.findById(tid, function(err, thread) {
			if (err) {
				console.error(err);
				res.json(returnCode.BUSY);
			} else {
				rs.data = thread;
				res.json(_.assign(rs, returnCode.SUCCESS));
			}
		});
	} else {
		res.json(returnCode.WRONG_PARAM);
	}
});

//查询所有标签
router.get('/tag/list', function(req, res, next) {
	var pageNo = req.query.pageNo || 1;
    var pageSize = req.query.pageSize || 10;

	var rs = {};
	var group = new ForumGroup(req.body);
	ForumTag.count({ent_code:req.session.user.ent_code}, function (err, count) {
	   if(err){
	   		console.error(err);
			res.json(returnCode.BUSY);
	   }else{
	   		var skip = (pageNo - 1) * pageSize;
            var limit = count - skip > pageSize ? pageSize : (count - skip);
            ForumTag.find({ent_code:req.session.user.ent_code}, null, {skip: skip,limit:limit},function(err,docs){
				if (err) {
					console.error(err);
					res.json(returnCode.BUSY);
				} else {
					rs.total=count;
					rs.pageNo=pageNo;
					rs.pageSize=pageSize;
					rs.items=docs;
					res.json(_.assign(rs, returnCode.SUCCESS));
				}
			});
	   }
	});
});

//查询标签下的文章列表
router.get('/tag/:tid/threads', function(req, res, next) {
	var pageNo = req.query.pageNo || 1;
    var pageSize = req.query.pageSize || 10;
    var tid=req.params.tid;

	var rs = {};
	var group = new ForumGroup(req.body);
	ForumThread.count({ent_code:req.session.user.ent_code,tag:tid}, function (err, count) {
	   if(err){
	   		console.error(err);
			res.json(returnCode.BUSY);
	   }else{
	   		var skip = (pageNo - 1) * pageSize;
            var limit = count - skip > pageSize ? pageSize : (count - skip);
            ForumThread.find({ent_code:req.session.user.ent_code,tag:tid}, null, {skip: skip,limit:limit},function(err,docs){
				if (err) {
					console.error(err);
					res.json(returnCode.BUSY);
				} else {
					rs.total=count;
					rs.pageNo=pageNo;
					rs.pageSize=pageSize;
					rs.items=docs;
					res.json(_.assign(rs, returnCode.SUCCESS));
				}
			});
	   }
	});
});