'use strict';
var express = require('express'),
	router = express.Router(),
	returnCode = require('../../utils/returnCode'),
	_ = require('lodash');
var mongoose = require('mongoose');
var ForumThread = mongoose.model('ForumThread');
var forumThreadService=require('../../service/forumThreadService');
var forumRolePermissionService=require('../../service/forumRolePermissionService');
var forumPraiseLogService=require('../../service/forumPraiseLogService');
var forumShareLogService=require('../../service/forumShareLogService');
var forumCommentService=require('../../service/forumCommentService');
var async=require('async');
module.exports = function(app) {
	app.use('/admin/forum', router);
};


//---------------------文章表单操作---------------------------------

//新增论坛文章
router.post('/thread/create', function(req, res, next) {
	var rs = {};
	req.body.ent_code=req.session.user.ent_code;
	forumThreadService.createThread(req.body,function(err,entity){
		if (err) {
			console.error(err);
			res.json(returnCode.BUSY);
		} else {
			rs.data = {'id':entity._id};
			res.json(_.assign(rs, returnCode.SUCCESS));
		}
	});
});

//获取目标论坛文章
router.get('/thread/:tid/get', function(req, res, next) {
	var tid = req.params.tid || null;
	var rs = {};
	if (tid) {
		forumThreadService.getThreadById(tid,function(err,thread){
			if(err){
				res.json(returnCode.BUSY);
			}else{
				rs.data = thread;
				res.json(_.assign(rs, returnCode.SUCCESS));
			}
		});
	} else {
		res.json(returnCode.WRONG_PARAM);
	}
});

//更新文章状态、如：屏蔽
router.post('/thread/:tid/update', function(req, res, next) {
	var tid=req.params.tid;
	if(tid){
		forumThreadService.updateThreadById(tid,req.body,function(err,thread){
			if(err){
				res.json(returnCode.BUSY);
			}else{
				res.json(returnCode.SUCCESS);
			}
		});
	}else{
		res.json(returnCode.WRONG_PARAM);
	}
});

//删除文章
router.post('/thread/:tid/delete', function(req, res, next) {
	var tid=req.params.tid;
	if(tid){
		forumThreadService.deleteThreadById(tid,function(err,thread){
			if(err){
				res.json(returnCode.BUSY);
			}else{
				res.json(returnCode.SUCCESS);
			}
		});
	}else{
		res.json(returnCode.WRONG_PARAM);
	}
});